﻿function RetryPageAssistant() {

}

RetryPageAssistant.prototype.setup = function(){
	console.log("RetryPageAssistant.prototype.setup");
	//-----------------------------------------------------------------------------
	//---------------------init--debugMode--trace------------------------------
	//-----------------------------------------------------------------------------
	this.trace = viewUtil.trace;
	this.trace("RetryPageAssistant init Scene");
	
	if (spark.globalUIObject.currentDevice) {
		$('deviceTitle').innerHTML = spark.globalUIObject.currentDevice.name;
	}
	else
	{
		$('deviceTitle').innerHTML = "";
	}
	
	this.buttonFunctions = {
		retryDown: function(event){
			var data = $A(arguments);
			data.shift();
			var imageID = data[0];
			viewUtil.rollOver(imageID);
			huf.navigator.popView();
		},
		
		retryUp: function(event){
			var data = $A(arguments);
			data.shift();
			var imageID = data[0];
			viewUtil.rollOut(imageID);
		}
	}
	
	
	Event.observe($("retryBtnDiv"), "touchstart", this.buttonFunctions.retryDown.bindAsEventListener(this, 'retryImageDiv'));
	Event.observe($("retryBtnDiv"), "touchend", this.buttonFunctions.retryUp.bindAsEventListener(this, 'retryImageDiv'));
	
	Event.observe($("abortBtnDiv"), "touchstart", this.buttonFunctions.retryDown.bindAsEventListener(this, 'abortImageDiv'));
	Event.observe($("abortBtnDiv"), "touchend", this.buttonFunctions.retryUp.bindAsEventListener(this, 'abortImageDiv'));
	
	

	
	this.trace("RetryPageAssistant complete");
};

RetryPageAssistant.prototype.activate = function(event) {
	console.log("RetryPageAssistant.prototype.activate");
};

RetryPageAssistant.prototype.deactivate = function(event) {
	console.log("RetryPageAssistant.prototype.deactivate");
};

RetryPageAssistant.prototype.cleanup = function(event) {
	console.log("RetryPageAssistant.prototype.cleanup");
};
