﻿function ModuleSelectionAssistant() {
}

ModuleSelectionAssistant.prototype.setup = function(){
	console.log("ModuleSelectionAssistant.prototype.setup");
	//-----------------------------------------------------------------------------
	//---------------------init--debugMode--trace------------------------------
	//-----------------------------------------------------------------------------
	spark.globalUIObject.debugMode=true;
	this.bShowAnimate=true;
	this.trace = viewUtil.trace;
	this.trace("init Scene");
		
	//-------------------------------------------------------------------------------------------
	//---------BackBtn---------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	
	this.backBtnPressed = function(e){
		$("moduleSelection-backBtn").style.opacity=0.5;
	}.bind(this)
	
	this.backBtnReleased = function(e){
		$("moduleSelection-backBtn").style.opacity=1;
		//huf.navigator.popView();
		spark.globalUIObject.nFailedCount = 0;
		huf.navigator.popViewsTo("Scanning");
	}.bind(this)
	
	Event.observe($("moduleSelection-backBtn"), viewUtil.clickEventName(), this.backBtnPressed);
	Event.observe($("moduleSelection-backBtn"), viewUtil.clickUpEventName(), this.backBtnReleased);
	
	//-------------------------------------------------------------------------------------------	
	//---------Module buttons----------------------------------------------------------------
	//-------------------------------------------------------------------------------------------	

	this.moduleFunctions = {
		moduleButtonUp: function(e){
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			var moduleID = data[1];
			var moduleName = data[2];
			
			var nHeight = huf.pal.getResolutionHeight();
			var nWidth = huf.pal.getResolutionWidth();
			if ((nHeight >= 924 && nHeight <= 1124 && nWidth == 600) || (nHeight == 600 && nWidth >= 924 && nWidth <= 1124)) {
				if (nHeight > nWidth){
					nHeight = 1024;
				}
				else{
					nWidth = 1024;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1380 && nWidth == 800) || (nHeight == 800 && nWidth >= 1180 && nWidth <= 1380)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1280 && nWidth == 720) || (nHeight == 720 && nWidth >= 1180 && nWidth <= 1280)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			var strResolution = "";
			if (nHeight > nWidth)
			{
				strResolution = "" + nHeight + "" + nWidth;
			}
			else 
			{
				strResolution = "" + nWidth + "" + nHeight;
			}
			//moduleID.style.opacity=1;
			
			e.preventDefault();
			
			this.trace("moduleFunctions : " + oper);
			moduleID.style.background = "url(../Resource/" + strResolution + "/images/module/n_" + moduleName + ".png)";
			spark.globalUIObject.currentService.selectModule(oper);
			huf.navigator.pushView("MediaControl", MediaControlAssistant);
		},
		moduleButtonDown: function(e){
			var data = $A(arguments);
			data.shift();
			var moduleID = data[0];
			var moduleName = data[1];
			
			//moduleID.style.opacity=0.5;
			
			var nHeight = huf.pal.getResolutionHeight();
			var nWidth = huf.pal.getResolutionWidth();
			if ((nHeight >= 924 && nHeight <= 1124 && nWidth == 600) || (nHeight == 600 && nWidth >= 924 && nWidth <= 1124)) {
				if (nHeight > nWidth){
					nHeight = 1024;
				}
				else{
					nWidth = 1024;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1380 && nWidth == 800) || (nHeight == 800 && nWidth >= 1180 && nWidth <= 1380)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1280 && nWidth == 720) || (nHeight == 720 && nWidth >= 1180 && nWidth <= 1280)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			var strResolution = "";
			if (nHeight > nWidth)
			{
				strResolution = "" + nHeight + "" + nWidth;
			}
			else 
			{
				strResolution = "" + nWidth + "" + nHeight;
			}
			
			e.preventDefault();
			moduleID.style.background = "url(../Resource/" + strResolution + "/images/module/p_" + moduleName + ".png)";
		}
	}
	
	/* Define module template */
	var moduleTemplate = {		
		"buttonTemplate" : [["moduleButton5"],
						   ["moduleButton4", "moduleButton6"],
						   ["moduleButton2", "moduleButton5", "moduleButton8"],
						   ["moduleButton1", "moduleButton3", "moduleButton4", "moduleButton6"],
						   ["moduleButton2", "moduleButton4", "moduleButton7", "moduleButton6", "moduleButton9"]],
		
		"textTemplate" : [["moduleText5"],
		                  ["moduleText4", "moduleText6"],
		                  ["moduleText2", "moduleText5", "moduleText8"],
		                  ["moduleText1", "moduleText3", "moduleText4", "moduleText6"],
		                  ["moduleText2", "moduleText4", "moduleText7", "moduleText6", "moduleText9"]]
	}
	/* For text translating */
	var moduleTextArray = {"Movie" : "Фильм", 
	                       "Video" : "Video",
	                       "Photo" : "Фото", 
	                       "Music" : "Музыка", 
	                       "Device": "Устройство"};
	
	/* Get the template by number of modules */
	var bRemote20 = (spark.globalUIObject.apiVersion == 2.0);
	var moduleNumber = bRemote20 ? spark.globalUIObject.controlInfo.supportFeature.length
								 : spark.globalUIObject.moduleArray.length;
	console.log("ModuleSelection moduleNumber" + moduleNumber);
	
	var buttonTemplate = moduleTemplate.buttonTemplate[moduleNumber-1];
	var textTemplate = moduleTemplate.textTemplate[moduleNumber-1];
		
	/* Query and setup module button */
	for (var i = 0; i < moduleNumber; ++i)
	{
		var moduleName = bRemote20 ? spark.globalUIObject.controlInfo.supportFeature[i]
								   : spark.globalUIObject.moduleArray[i];
		
		var moduleButtonID = $(moduleName + 'ModuleBtn');
		var moduleTextID = $(moduleName + 'ModuleText');
		
		moduleButtonID.className = buttonTemplate[i];
		moduleTextID.className = textTemplate[i];
		moduleTextID.innerHTML = moduleTextArray[moduleName];
		
		// align the edge of module button
		moduleButtonID.style.height = moduleButtonID.clientWidth + "px";
		
		Event.observe(moduleButtonID, viewUtil.clickDownEventName(), this.moduleFunctions.moduleButtonDown.bindAsEventListener(this, moduleButtonID, moduleName));
		Event.observe(moduleButtonID, viewUtil.clickUpEventName(), this.moduleFunctions.moduleButtonUp.bindAsEventListener(this, i, moduleButtonID, moduleName));
	}
	
	//-------------------------------------------------------------------------------------------
	//-------- WebSite --------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------	
	
	this.websiteBtnClicked = function(e){
		// link to webiside, define in html
		huf.pal.browseURL("http://www.cyberlink.com");
	}.bind(this)
	
	Event.observe($("moduleSelection-webSiteText"), viewUtil.clickEventName(), this.websiteBtnClicked);
	
	var nHeight = huf.pal.getResolutionHeight();
	var nWidth = huf.pal.getResolutionWidth();
	var strResolution = "";
	if (nHeight > nWidth)
	{
		strResolution = "" + nHeight + "" + nWidth;
	}
	else 
	{
		strResolution = "" + nWidth + "" + nHeight;
	}
	$('pdvdLogo').src = "../Resource/" + strResolution + "/images/launch/logo_PDVD.png";
	
	this.trace("complete");
};

ModuleSelectionAssistant.prototype.activate = function(event) {
	/* Opening animantion */
	if (true == this.bShowAnimate)
	{
		$('pdvdLogo').puff({ duration: 0.5, delay:0.7 });
		$('moduleSelection-midDiv').hide();
		$('moduleSelection-midDiv').appear({delay:1});
		this.bShowAnimate = false;
	}
	
	// check permission
	spark.globalUIObject.currentService.checkPermission()
	
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
};

ModuleSelectionAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

ModuleSelectionAssistant.prototype.cleanup = function(event) {
	
	Event.stopObserving($("moduleSelection-backBtn"), viewUtil.clickEventName(), this.backBtnPressed);
	Event.stopObserving($("moduleSelection-backBtn"), viewUtil.clickUpEventName(), this.backBtnReleased);
	Event.stopObserving($("moduleSelection-webSiteText"), viewUtil.clickEventName(), this.websiteBtnClicked);
	
	var bRemote20 = (spark.globalUIObject.apiVersion == 2.0);
	var moduleNum = bRemote20 ? spark.globalUIObject.controlInfo.supportFeature.length
							  : spark.globalUIObject.moduleArray.length;
	
	for (var i = 0; i < moduleNum; i++)
	{
		var moduleName = bRemote20 ? spark.globalUIObject.controlInfo.supportFeature[i]
								   : spark.globalUIObject.moduleArray[i];
		var moduleButtonID = $(moduleName + 'ModuleBtn');
		
		Event.stopObserving(moduleButtonID, viewUtil.clickDownEventName(), this.moduleFunctions.moduleButtonDown);
		Event.stopObserving(moduleButtonID, viewUtil.clickUpEventName(), this.moduleFunctions.moduleButtonUp);
	}
	
	/* stop Media Share */
	spark.globalUIObject.currentService.stopMediaShare();
	// send stop http command
	if (false != spark.globalUIObject.bIsPasswordValid)
	{
		spark.globalUIObject.currentService.stopServer();
	}
	
	spark.globalUIObject.nFailedCount = 0;
	huf.navigator.popViewsTo("Scanning");

	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
};
